-- MySQL Script generated by MySQL Workbench
-- Fri Jun 15 21:15:02 2018
-- Model: New Model    Version: 1.0
-- MySQL Workbench Forward Engineering

SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL,ALLOW_INVALID_DATES';

-- -----------------------------------------------------
-- Schema locadora
-- -----------------------------------------------------

-- -----------------------------------------------------
-- Schema locadora
-- -----------------------------------------------------
CREATE SCHEMA IF NOT EXISTS `locadora` DEFAULT CHARACTER SET utf8 ;
USE `locadora` ;

-- -----------------------------------------------------
-- Table `locadora`.`Cliente`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `locadora`.`Cliente` (
  `Id` INT NOT NULL AUTO_INCREMENT,
  `Nome` VARCHAR(45) NULL,
  `CPF` CHAR(11) NULL,
  `RG` VARCHAR(15) NULL,
  `Telefone` VARCHAR(12) NULL,
  `Email` VARCHAR(45) NULL,
  PRIMARY KEY (`Id`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `locadora`.`Funcionario`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `locadora`.`Funcionario` (
  `Id` INT NOT NULL AUTO_INCREMENT,
  `Matricula` VARCHAR(20) NULL,
  `Nome` VARCHAR(45) NULL,
  `CPF` VARCHAR(45) NULL,
  `RG` VARCHAR(45) NULL,
  `Salario` DECIMAL(15,2) NULL,
  `Login` VARCHAR(45) NULL,
  `Senha` VARCHAR(45) NULL,
  PRIMARY KEY (`Id`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `locadora`.`Filme`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `locadora`.`Filme` (
  `Id` INT NOT NULL AUTO_INCREMENT,
  `Titulo` VARCHAR(45) NULL,
  `Descricao` VARCHAR(45) NULL,
  `Preco` DECIMAL(15,2) NULL,
  `NumeroDias` INT NULL,
  `Categoria` VARCHAR(45) NULL,
  `Diretor` VARCHAR(45) NULL,
  `Duracao` INT NULL,
  PRIMARY KEY (`Id`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `locadora`.`Jogo`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `locadora`.`Jogo` (
  `Id` INT NOT NULL AUTO_INCREMENT,
  `Titulo` VARCHAR(45) NULL,
  `Descricao` VARCHAR(45) NULL,
  `Preco` DECIMAL(15,2) NULL,
  `NumeroDias` INT NULL,
  `Categoria` VARCHAR(45) NULL,
  `Memoria` INT NULL,
  `Tipo` VARCHAR(45) NULL,
  PRIMARY KEY (`Id`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `locadora`.`Locacao`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `locadora`.`Locacao` (
  `Id` INT NOT NULL AUTO_INCREMENT,
  `DataLocacao` TIMESTAMP NULL,
  `DataDevolucao` TIMESTAMP NULL,
  `ClienteId` INT NOT NULL,
  `FuncionarioId` INT NOT NULL,
  PRIMARY KEY (`Id`),
  INDEX `fk_Locacao_Cliente_idx` (`ClienteId` ASC),
  INDEX `fk_Locacao_Funcionario1_idx` (`FuncionarioId` ASC),
  CONSTRAINT `fk_Locacao_Cliente`
    FOREIGN KEY (`ClienteId`)
    REFERENCES `locadora`.`Cliente` (`Id`)
    ON DELETE RESTRICT
    ON UPDATE CASCADE,
  CONSTRAINT `fk_Locacao_Funcionario1`
    FOREIGN KEY (`FuncionarioId`)
    REFERENCES `locadora`.`Funcionario` (`Id`)
    ON DELETE RESTRICT
    ON UPDATE CASCADE)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `locadora`.`LocacaoFilme`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `locadora`.`LocacaoFilme` (
  `LocacaoId` INT NOT NULL,
  `FilmeId` INT NOT NULL,
  PRIMARY KEY (`LocacaoId`, `FilmeId`),
  INDEX `fk_Locacao_has_Filme_Filme1_idx` (`FilmeId` ASC),
  INDEX `fk_Locacao_has_Filme_Locacao1_idx` (`LocacaoId` ASC),
  CONSTRAINT `fk_Locacao_has_Filme_Locacao1`
    FOREIGN KEY (`LocacaoId`)
    REFERENCES `locadora`.`Locacao` (`Id`)
    ON DELETE RESTRICT
    ON UPDATE CASCADE,
  CONSTRAINT `fk_Locacao_has_Filme_Filme1`
    FOREIGN KEY (`FilmeId`)
    REFERENCES `locadora`.`Filme` (`Id`)
    ON DELETE RESTRICT
    ON UPDATE CASCADE)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `locadora`.`LocacaoJogo`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `locadora`.`LocacaoJogo` (
  `LocacaoId` INT NOT NULL,
  `JogoId` INT NOT NULL,
  PRIMARY KEY (`LocacaoId`, `JogoId`),
  INDEX `fk_Locacao_has_Jogo_Jogo1_idx` (`JogoId` ASC),
  INDEX `fk_Locacao_has_Jogo_Locacao1_idx` (`LocacaoId` ASC),
  CONSTRAINT `fk_Locacao_has_Jogo_Locacao1`
    FOREIGN KEY (`LocacaoId`)
    REFERENCES `locadora`.`Locacao` (`Id`)
    ON DELETE RESTRICT
    ON UPDATE CASCADE,
  CONSTRAINT `fk_Locacao_has_Jogo_Jogo1`
    FOREIGN KEY (`JogoId`)
    REFERENCES `locadora`.`Jogo` (`Id`)
    ON DELETE RESTRICT
    ON UPDATE CASCADE)
ENGINE = InnoDB;


SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;
